#include "AST.h"
#include "CodeContext.h"
#include "UniqueId.h"


UniqueId IterationNode::generator( "continue" );


IterationNode::IterationNode()
    : continueLabel( generator.next() )
{
}


void IterationNode::emitContinueTarget( ostream &os ) const
{
    os << continueLabel << ": ;" << endCline;
}


void IterationNode::unwindContinue( CodeContext &context, const TreeNode &destination ) const
{
    unwind( context );
    
    if (&destination == this)
	context << "goto " << continueLabel << ";" << endCline;
    else
      parent()->unwindContinue( context, destination );
}
