AC_DEFUN(TI_FIX_SHELL,[
AC_MSG_CHECKING(for good shell)
if test "$BASH" = '' && test `uname` = HP-UX; then
  AC_MSG_RESULT([no, switching to bash])
  case [$]# in
    0) exec bash - "[$]0"        ;;
    *) exec bash - "[$]0" "[$]@" ;;
  esac
else
  AC_MSG_RESULT(yes)
fi])

AC_DEFUN(TI_COMPILER,[
AC_PROG_$1
if test $2 = yes; then $3="$$3 -Wall"; fi])

AC_DEFUN(TI_ENV_DEFAULT,[
AC_MSG_CHECKING(for $1 in environment)
case "$[$1]" in
  '') [$1]="[$2]"
      AC_MSG_RESULT([no, defaulting to \"[$2]\"])
      ;;
  *)  AC_MSG_RESULT([yes, using \"$[$1]\"]) ;;
esac
])

AC_DEFUN(TI_OPTION_HELP,[  --$1 substr([                     ],len($1))$2])

AC_DEFUN(TI_IF_ENABLED,[
AC_ARG_ENABLE($1,TI_OPTION_HELP(enable-$1,$2))
case "$enable_[]patsubst([$1], -, _)" in
  '' | no) $4 ;;
  *)  $3 ;;
esac
])

AC_DEFUN(TI_IF_DISABLED,[
AC_ARG_ENABLE($1,TI_OPTION_HELP(disable-$1,$2))
case "$enable_[]patsubst([$1], -, _)" in
  '' | yes) $4 ;;
  *)   $3 ;;
esac
])

AC_DEFUN(TI_IF_ENABLED_WITH_AUTO,[
AC_ARG_ENABLE($1,TI_OPTION_HELP(enable-$1,$2))
case "$enable_[]patsubst([$1], -, _)" in
  no)  $4 ;;
  yes) $3 ;;
  *)   $5 ;;
esac
])

AC_DEFUN(TI_SUBST,[
$1="$2"
AC_SUBST($1)])

AC_DEFUN(TI_SUBST_FILE,[
$1="$2"
AC_SUBST_FILE($1)])

AC_DEFUN(TI_CHECK_PROGS,[
case "$$1" in
  '') AC_CHECK_PROGS($1,$2)
      ;;
esac
case "$$1" in
  '') AC_MSG_ERROR(cannot find $3)
      ;;
esac])

AC_DEFUN(TI_CHECK_LIB,[
oldflags="$LDFLAGS"
LDFLAGS="-L$1 $LD_FLAGS"
AC_CHECK_LIB($2, $3, $4, $5, $6)
LDFLAGS="$oldflags"])

AC_DEFUN(TI_FIX_EXEC,[[
case "$CONFIG_FILES" in
  *$1*) chmod +x $1 ;;
esac]])

AC_DEFUN(TI_CHECK_PERL,[
if test -n "$$1"; then
  AC_MSG_CHECKING($$1 for perl version 5.004 or later)
  if "$$1" -e 'require 5.004;' 2>&AC_FD_CC; then
    AC_MSG_RESULT(yes)
    PERL="$$1"
  else
    AC_MSG_RESULT(no)
    unset PERL $1
  fi
fi
case "$PERL" in
 '') $3 ;;
 *)  $2 ;;
esac]
)


AC_DEFUN(TI_TRY_CFLAG,[
oldflags="$CFLAGS"
CFLAGS="$CFLAGS $1"
AC_LANG_SAVE
AC_LANG_C
AC_TRY_COMPILE([], [], $2=yes, $2=no)
AC_LANG_RESTORE
CFLAGS="$oldflags"])


AC_DEFUN(TI_TRY_CXXFLAG,[
oldflags="$CXXFLAGS"
CXXFLAGS="$CXXFLAGS $1"
AC_LANG_SAVE
AC_LANG_CPLUSPLUS
AC_TRY_COMPILE([], [], $2=yes, $2=no)
AC_LANG_RESTORE
CXXFLAGS="$oldflags"])
