#include "../code-files/CfCode.h"
#include "../code-files/CfLayout.h"
#include "CtGlobal.h"


void CtGlobal::declare( CfFile &out ) const
{
  out << "#ifdef WIDE_POINTERS\n";
  CtDefined::declare( out );
  out << "#else\n";
  define( out );
  out << "#endif\n";
}


void CtGlobal::elaborate( CfLayout &out ) const
{
  CtReference::elaborate( out );
  
  out << "#ifdef WIDE_POINTERS\n"
      << "struct " << name << " {\n"
      << "  int proc;\n"
      << "  " << referent.name << " *addr;\n"
      << "};\n";
  CtDefined::declare( out );
  out << "#else\n"
      << "typedef " << referent.name << " *" << name << ";\n"
      << "#endif\n";
}


const char *CtGlobal::titaniumArrayPrefix() const
{
  return "GLOBAL_";
}


// Local Variables:
// c-file-style: "gnu"
// End:
