#include <strstream>
#include "../PrimitiveDecl.h"
#include "../domain-decls.h"
#include "CtPointInstance.h"
#include "CtRegistry.h"


CtPointInstance::CtPointInstance( unsigned arity )
  : CtInstance( *PointNDecl[ arity - 1 ] ),
    arity( arity )
{
}


void CtPointInstance::dependFields( CtRegistry &registry ) const
{
  registry.add( PrimitiveDecl::IntDecl.cType() );
}


void CtPointInstance::defineFields( ostream &out ) const
{
  const CtType &cInt = PrimitiveDecl::IntDecl.cType();
  
  for (unsigned dimension = 0; dimension < arity; ++dimension)
    out << cInt << ' ' << 'x' << dimension << ";\n";
}


// Local Variables:
// c-file-style: "gnu"
// End:
