#include <fstream.h>
#include "AST.h"
#include "CodeContext.h"
#include "CtType.h"


const string BroadcastNode::emitExpression2( CodeContext &context )
{
  const string result = declareTemporary( context );
  const string process = proc()->defineTemporary( context );
  const string typeName = expr()->type()->cType().name;

  CodeContext subcontext( context );
  subcontext << "BROADCAST_BEGIN( " << typeName << ", " << process << " );" << endCline;
  
  // everybody checks the processor number
  subcontext << "if (" << process << " == MYPROC)" << endCline;
  {
    CodeContext sender( subcontext );
    const string value = expr()->defineTemporary( sender );
    sender << "  BROADCAST_SEND( " << result << ", " << typeName << ", " << value << " );" << endCline;
  }
  subcontext << "else" << endCline
	     << "  BROADCAST_RECEIVE( " << result << ", " << typeName << ", " << process << " );" << endCline
	     << "BROADCAST_END( " << result << ", " << typeName << ", " << process << " );" << endCline;
  
  return result;
}
