#include "AST.h"
#include "solver.h"


void DynamicTypeNode::inferLocal( const LocalContext )
{
  dtype()->localProtect();
  opnd0()->type()->localCastTo( *dtype() );
}


////////////////////////////////////////////////////////////////////////


void TypeNode::localCastTo( const TypeNode &target ) const
{
  if (localInferable() && target.localInferable() && !target.isLocal())
    solver().subsumedBy( *this, target );
}


////////////////////////////////////////////////////////////////////////


void ArrayTypeNode::localCastTo( const TypeNode &target ) const
{
  TypeNode::localCastTo( target );
  
  if (target.isArrayType())
    elementType()->localSubcastTo( *target.elementType() );
  else
    elementType()->localConservative();
}


void DomainTypeNode::localCastTo( const TypeNode &target ) const
{
  if (!target.isRectDomainType())
    TypeNode::localCastTo( target );
}


void TypeNameNode::localCastTo( const TypeNode &target ) const
{
  TypeNode::localCastTo( target );

  if (target.isArrayType())
    target.elementType()->localConservative();
}
