#include "AST.h"
#include "context.h"
#include "decls.h"


void TreeNode::inferLocalTree()
{
  inferLocalTree( LocalContext() );
}


void TreeNode::inferLocalTree( const LocalContext context )
{
  inferLocalChildren( context );
  inferLocal( context );
}


void TreeNode::inferLocalChildren( const LocalContext context ) const
{
  for (unsigned sweep = arity(); sweep--; )
    child( sweep )->inferLocalTree( context );
}


void TreeNode::inferLocal( const LocalContext )
{
}


////////////////////////////////////////////////////////////////////////


void ConstructorDeclNode::inferLocalChildren( const LocalContext ) const
{
  MethodTypeNode *context = decl()->methodType();
  TreeNode::inferLocalChildren( context );
}


void MethodDeclNode::inferLocalChildren( const LocalContext ) const
{
  MethodTypeNode *context = decl()->methodType();
  TreeNode::inferLocalChildren( context );
}
