#include "AST.h"
#include "solver.h"


void TypeNode::localSimilarTo( const TypeNode &other ) const
{
}


void ArrayTypeNode::localSimilarTo( const TypeNode &other ) const
{
  if (other.isArrayType())
    elementType()->localSubsimilarTo( *other.elementType() );
}


////////////////////////////////////////////////////////////////////////


void TypeNode::localSubsimilarTo( const TypeNode &other ) const
{
  if (localInferable())
    solver().identicalTo( *this, other );
}


void JavaArrayTypeNode::localSubsimilarTo( const TypeNode &other ) const
{
  TypeNode::localIdenticalTo( other );

  if (other.isArrayType())
    elementType()->localSubsimilarTo( *other.elementType() );
  else
    assert( other.decl() == ObjectDecl );
}


void TitaniumArrayTypeNode::localSubsimilarTo( const TypeNode &other ) const
{
  TypeNode::localIdenticalTo( other );
  elementType()->localSubsimilarTo( *other.elementType() );
}
