#include <iostream.h>
#include "AST.h"
#include "CfCode.h"
#include "FieldDecl.h"
#include "code.h"
#include "nullify-local.h"


void fieldNullifyLocal( FieldDecl &field, CfCode &os )
{
  field.type()->emitNullifyLocal( os, "me->" + field.cFieldName() );
}


void TypeNode::emitNullifyLocal( ostream &os, const string &target ) const
{
  assert( isReference() );
  if (isLocal())
    os << target << " = 0;\n";
}


////////////////////////////////////////////////////////////////////////


void PointTypeNode::emitNullifyLocal( ostream &, const string & ) const
{
}


void PrimitiveTypeNode::emitNullifyLocal( ostream &, const string & ) const
{
}


void RectDomainTypeNode::emitNullifyLocal( ostream &, const string & ) const
{
}


void TitaniumArrayTypeNode::emitNullifyLocal( ostream &os, const string &target ) const
{
  if (isLocal())
    os << target << ".A = 0;\n"
       << target << ".ancestor = 0;\n"
       << target << ".where = \"nullified by clone\";\n";
}


void TypeNameNode::emitNullifyLocal( ostream &os, const string &target ) const
{
  if (isImmutable())
    os << decl()->cNullifyLocalName() << "(&" << target << ");\n";
  else
    TypeNode::emitNullifyLocal( os, target );
}
