#include <stdio.h>
#include <stdlib.h>
#include <thread.h>

#include <backend.h>
#include "main.h"


int PROCS;
char *RUNTIME_MODEL = "smp";

int ti_argc;
char **ti_argv;


#ifdef NO_PROCID_REGISTER
int thread_map[100];
#endif


void ti_set_proc(int p)
{
    MYPROC = p;
}

#include "thread_ctl.c"


int main(int argc, char **argv)
{
    const char * envar;

    ti_argc = argc;
    ti_argv = argv;

    envar = getenv( "TI_NODES" );
    if (envar)
      {
	char *end;
	PROCS = strtol( envar, &end, 0 );

	if (*end || PROCS <= 0)
	  {
	    fprintf (stderr,
		     "%s: (Error) Environment variable TI_NODES must be a number greater than zero: \"%s\".\n",
		     argv[0] ? argv[0] : "<Unknown>",
		     envar ? envar : "<Unknown>");
	    return -1;
	  }
      }
    else
      PROCS = 1;

    /* Make sure GC is initialised before creating threads */
    ti_mem_thr_init(&argv);
    region_init();

    Tit_Thread_Init();
    exit(0);
}
