static long /* single */ STATIC_DEF(nextSharedId);

void cl_ti_lang_Ti_mt_barrier(void);

#ifndef BACKEND_UNIPROC
#define MAXSREGIONS 1024
Region STATIC_DEF(__sregionidmap[MAXSREGIONS]);
#endif

struct cl_ti_lang_SharedRegion *newsregion(void)
{
  struct cl_ti_lang_Region *r = newregion();
  struct cl_ti_lang_SharedRegion *sr = (struct cl_ti_lang_SharedRegion *)r;

  cl_ti_lang_SharedRegion_mt_SharedRegion(sr);
  STATIC_REF(nextSharedId) += 2;
  r->id = STATIC_REF(nextSharedId) + 1;
  initregion(r);
#ifndef BACKEND_UNIPROC
  if ((r->id >> 1) >= MAXSREGIONS) abort();
  STATIC_REF(__sregionidmap[r->id >> 1]) = (Region)r;
#endif

  /* Synchronise to ensure that all procs have created the region
     before any proc returns (otherwise races are possible where
     one process sees objects in a not-yet-created-locally
     shared region) */
  cl_ti_lang_Ti_mt_barrier();

  return sr;
}

void cl_ti_lang_SharedRegion_mt_delete_G(GP_cl_ti_lang_SharedRegion me)
{
  /* Make sure we get the local representative of the region */
  Region r = MyGRegion(*(GRegion*)&me);

  /* Don't start freeing memory before everyone gets here */
  cl_ti_lang_Ti_mt_barrier();

  deleteregion(r);
}
