package ti.lang;

public class Timer {
  public static long MAX_US = 2146; // max microsecond-representable secs.
  public static long MAX_MS = 2147483; // max millisecond-representable secs.
  long curSec, curUsec;
  public long elapSec, elapUsec;

  public Timer() { elapSec = 0; elapUsec = 0; curSec = 0; curUsec = 0;}
  public local native void gettimeofday_local();
  public native void gettimeofday_global();

  public void gettimeofday() {
    if (isLocal()) {
      Timer local t = (Timer local)this;
      t.gettimeofday_local();
    }
    else {
      gettimeofday_global();
    }
  }
  
  public void start() {
    gettimeofday();
  }

  public void stop() {
    long oldCurSec = curSec, oldCurUsec = curUsec;
    gettimeofday();
    elapSec += curSec - oldCurSec;
    elapUsec += curUsec - oldCurUsec;
  }

  public void reset() { elapSec = 0; elapUsec = 0; }
  public double secs() { return ((double)elapSec) + ((double)elapUsec / 1000000.); }

  public double micros() {
    if (elapSec > MAX_US) {
      return -1;
    }
    else {
      return (double)((elapSec * 1000000) + elapUsec);
    }
  }

  public double millis() {
    if (elapSec > MAX_MS) {
      return -1;
    }
    else {
      return ((double)(elapSec * 1000)) + ((double)elapUsec / 1000.);
    }
  }
}
